function v=MSedge(u,alpha,beta,epsilon)
%This function give a Mumford-edge for a given image u
%Input:                 u --- the given image
%    alpha, beta, epsilon --- the parameters.

[n,m]=size(u);
h=1/n;
%h1=1/n;h2=1/m;

%gx=diff(u,1,2);gx=[gx zeros(n,1)];
%gy=diff(u,1,1);gy=[gy;zeros(1,m)];

gx1=diff(u,1,2);gx1=[gx1 gx1(:,m-1)];
gx2=diff(u,1,2);gx2=[gx2(:,m-1) gx2];
gy1=diff(u,1,1);gy1=[gy1;gy1(n-1,:)];
gy2=diff(u,1,1);gy2=[gy2(n-1,:);gy2];

%s=gx.^2+gy.^2;
s=((gx1+gx2)/2).^2+((gy1+gy2)/2).^2;

L1=gallery('tridiag',n,-1,2,-1);
L1(1,1)=1;L1(n,n)=1;

L2=gallery('tridiag',m,-1,2,-1);
L2(1,1)=1;L2(m,m)=1;

A=kron(L1,speye(m))+kron(speye(n),L2);

B=spdiags(s(:),0,m*n,m*n);

C=speye(m*n);

Co=2*beta*B+alpha/(2*epsilon)*C+2*alpha*epsilon*A;
b=alpha/(2*epsilon)*ones(m*n,1);

%Co=2*beta*B+h^2*alpha*C/(2*epsilon)+2*alpha*epsilon*A;
%b=h^2*alpha*ones(m*n,1)/(2*epsilon);

%dia=spdiags(diag(Co),0,n*m,n*m);
[L,U] = luinc(Co,.001);
v = pcg(Co,b,1e-6,10000,L,U);
v=reshape(v,n,m);
